﻿using System;
using System.Net;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Documents;
using System.Windows.Ink;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Animation;
using System.Windows.Shapes;
using System.Collections.ObjectModel;
using System.ComponentModel;

namespace _2010_12_02_XamGridComboEditor
{

    public class Persons: ObservableCollection<Person>
    {

    }


    public class Person : INotifyPropertyChanged
    {
        int _id;
        string _fName;
        string _lName;
        int? _stateId;
        int _countyId;
        string _personCategory;



        public Person(int id, string fName, string lName, int statId, int countyId, string catName)
        {
            _id = id;
            _fName = fName;
            _lName = lName;
            _stateId = statId;
            _countyId = countyId;
            _personCategory = catName;
        }

        public int Id
        {
            get { return _id; }
            set 
            {
                _id = value;
                Notify("Id");
            }
        }

        public string FName
        {
            get { return _fName; }
            set
            {
                _fName = value;
                Notify("FName");
            }
        }

        public string LName
        {
            get { return _lName; }
            set 
            {
                _lName = value;
                Notify("LName");
            }
        }

        public int? StateId
        {
            get { return _stateId; }
            set 
            { 
                _stateId = value;
                Notify("StateId");
                // Clear Country ID as we will have to pick a new one from the updated State list.
             //   CountyId = null;
            }
        }

        public int CountyId
        {
            get { return _countyId; }
            set
            {
                _countyId = value;
                Notify("CountyId");
            }
        }

        public string PersonCategory
        {
            get { return _personCategory; }
            set
            { 
                _personCategory = value;
                Notify("PersonCategory");
            }
        }


        public event PropertyChangedEventHandler PropertyChanged;


        #region INotifyPropertyChanged Members

        /// <summary>
        /// 	<para>
        ///         This method raises the <see cref="PropertyChanged">PropertyChanged</see> event
        ///         and is required by the INotifyPropertyChanged interface. It’s called in nearly
        ///         all public data field properties.
        ///     </para>
        /// 	<para>The <strong>INotifyPropertyChanged</strong> interface is used to notify
        ///     clients, typically binding clients, that a property value has changed. For more
        ///     information, search INotifyPropertyChanged on <strong>MSDN</strong>.</para>
        /// </summary>
        protected void Notify(string propName)
        {
            if (this.PropertyChanged != null)
            {
                PropertyChanged(this, new PropertyChangedEventArgs(propName));
            }
        }


        #endregion INotifyPropertyChanged Members



    }
}
